package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.ASTVisitor;
import org.eclipse.jdt.internal.compiler.ast.CompoundAssignment;
import org.eclipse.jdt.internal.compiler.ast.Expression;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;

public class PrefixExpression extends CompoundAssignment {
  public PrefixExpression(Expression lhs, Expression expression, int operator, int pos) {
    super(lhs, expression, operator, lhs.sourceEnd);
    this.sourceStart = pos;
    this.sourceEnd = lhs.sourceEnd;
  }
  
  public boolean checkCastCompatibility() {
    return false;
  }
  
  public String operatorToString() {
    switch (this.operator) {
      case 14:
        return "++";
      case 13:
        return "--";
    } 
    return "unknown operator";
  }
  
  public StringBuffer printExpressionNoParenthesis(int indent, StringBuffer output) {
    output.append(operatorToString()).append(' ');
    return this.lhs.printExpression(0, output);
  }
  
  public boolean restrainUsageToNumericTypes() {
    return true;
  }
  
  public void traverse(ASTVisitor visitor, BlockScope scope) {
    if (visitor.visit(this, scope))
      this.lhs.traverse(visitor, scope); 
    visitor.endVisit(this, scope);
  }
}
